{$APPTYPE CONSOLE}
{$R+}
// 20080115. Version 1.
// 20080117. Version 2.

uses
  SysUtils;

var
  f: TextFile;
  i, j, k, W, H, T, N, x, y, ya: Integer;
  a: array of array of array of Char;
  vv,vh: array of array of array of Boolean; 
  p: String;

  procedure Go(x, y, m: Integer; dir: Char);
  begin
    if (x >= 0) and (x < W) and (y >= 0) and (y < H) and (a[x, y, m] = '.') then
      a[x, y, m] := dir;
  end;

begin
  AssignFile(f, 'input.txt'); Reset(f);
  Read(f, W, H, T, ya, N);
  SetLength(a, W, H, T+1);
  SetLength(vv, W, H, T+1); SetLength(vh, W, H, T+1);
  for i := 0 to W - 1 do
    for j := 0 to H - 1 do
      for k := 0 to T do begin
        a[i, j, k] := #0; 
        vv[i, j, k] := (i mod 2) = 1; vh[i][j][k] := (j mod 2) = 1;
      end;

  for i := 1 to N do begin
    Read(f, x, y, p);
    p := Trim(p);
    Dec(x); Dec(y);
    Assert(Length(p) = T);
    for j := 0 to T - 1 do begin
      a[x, y, j] := '@';
      for k := x + 1 to W - 1 do vh[k, y, j] := false;
      for k := y + 1 to H - 1 do vv[x, k, j] := false;
      case p[j + 1] of
        'n': Dec(y);
        's': Inc(y);
        'w': Dec(x);
        'e': Inc(x);
        'z': ;
      end;
    end;
  end;
  for i := 0 to W - 1 do
    for j := 0 to H - 1 do
      for k := 0 to T do
        if a[i, j, k] <> '@' then begin
          if vh[i,j,k] or vv[i,j,k] then a[i, j, k] := '#'
            else a[i, j, k] := '.';
        end;
  CloseFile(f);
  x := W - 1;
  y := ya - 1;
  a[0, y, 0] := 'b';
  k := 0;
  while k < T do begin
    Inc(k);
    for j := 0 to H - 1 do begin
      for i := 0 to W - 1 do begin
        //Write(a[i, j, k - 1]);
        if a[i, j, k - 1] < 'a' then continue;
        Go(i, j - 1, k, 'n');
        Go(i, j + 1, k, 's');
        Go(i - 1, j, k, 'w');
        Go(i + 1, j, k, 'e');
        Go(i, j, k, 'z');
      end;
      //Writeln;
    end;
    //Writeln;
    if a[x, y, k] > 'a' then break;
  end;
  AssignFile(f, 'output.txt'); Rewrite(f);
  if (a[x, y, k] <= 'a') then
    Writeln(f, 'IMPOSSIBLE')
  else begin
    p := '';
    Writeln(k);
    while k > 0 do begin
      p := a[x, y, k] + p;
      case a[x, y, k] of
        'n': Inc(y);
        's': Dec(y);
        'w': Inc(x);
        'e': Dec(x);
        'z':;
      end;
      Dec(k);
    end;
    Writeln(f, p);
  end;
  CloseFile(f);
end.
